%     VIRTUAL LAMINATE - программа для получения эффективных свойств слоистых пластин
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Materials = Read_Materials_Mech()

global ErrCode;

Materials = [];

fprintf (1, 'Чтение свойств материалов...                            ');

% Открытие файла
File_Path = '_Materials_Mechanical.txt';
Fin = fopen(File_Path, 'r');

if (Fin < 0)
    fprintf (1, '\nОшибка функции Read_Materials_Mech: не удалось открыть файл %s !\n', File_Path);
    ErrCode = -1;
    return;
end

% Чтение файла
Materials = cell(1000,1);

counter = 0;

while (~feof(Fin))
    
    string = strtrim(fgets(Fin));
    
    if (isempty(string))
        continue;
    end
    
    if (string(1) == '#')
        continue;
    end
    
    temp_cell_array = strsplit(string, {' ', '\t'});
    
    if (isempty(temp_cell_array{1}) || isempty(temp_cell_array{size(temp_cell_array,2)}))
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    if (size(temp_cell_array, 2) < 17)
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    counter = counter + 1;
    
    Materials{counter}.ID = [];
    Materials{counter}.Name = [];
    
    Materials{counter}.E1 = [];
    Materials{counter}.E2 = [];
    Materials{counter}.E3 = [];
    
    Materials{counter}.G12 = [];
    Materials{counter}.G13 = [];
    Materials{counter}.G23 = [];
    
    Materials{counter}.nu12 = [];
    Materials{counter}.nu13 = [];
    Materials{counter}.nu23 = [];
    
    Materials{counter}.alpha11 = [];
    Materials{counter}.alpha22 = [];
    Materials{counter}.alpha33 = [];
    
    Materials{counter}.beta11 = [];
    Materials{counter}.beta22 = [];
    Materials{counter}.beta33 = [];
    
    Materials{counter}.t = [];
    
    % ID
    [tmp, count] = sscanf(temp_cell_array{1}, '%e');
    
    if (count == 1)
        Materials{counter}.ID = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % E1
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-15}, '%e');
    
    if (count == 1)
        Materials{counter}.E1 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % E2
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-14}, '%e');
    
    if (count == 1)
        Materials{counter}.E2 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % E3
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-13}, '%e');
    
    if (count == 1)
        Materials{counter}.E3 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % G12
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-12}, '%e');
    
    if (count == 1)
        Materials{counter}.G12 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % G13
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-11}, '%e');
    
    if (count == 1)
        Materials{counter}.G13 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % G23
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-10}, '%e');
    
    if (count == 1)
        Materials{counter}.G23 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % nu12
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-9}, '%e');
    
    if (count == 1)
        Materials{counter}.nu12 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % nu13
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-8}, '%e');
    
    if (count == 1)
        Materials{counter}.nu13 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % nu23
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-7}, '%e');
    
    if (count == 1)
        Materials{counter}.nu23 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % alpha11
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-6}, '%e');
    
    if (count == 1)
        Materials{counter}.alpha11 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % alpha22
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-5}, '%e');
    
    if (count == 1)
        Materials{counter}.alpha22 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % alpha33
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-4}, '%e');
    
    if (count == 1)
        Materials{counter}.alpha33 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % beta11
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-3}, '%e');
    
    if (count == 1)
        Materials{counter}.beta11 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % beta22
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-2}, '%e');
    
    if (count == 1)
        Materials{counter}.beta22 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % beta33
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)-1}, '%e');
    
    if (count == 1)
        Materials{counter}.beta33 = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % t
    [tmp, count] = sscanf(temp_cell_array{size(temp_cell_array, 2)}, '%e');
    
    if (count == 1)
        Materials{counter}.t = tmp(1);
    else
        fprintf (1, '\nОшибка: нарушен формат файла %s в строке [%s] !\n', File_Path, string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    % Name
    if (size(temp_cell_array, 2) > 17)
        
        Materials{counter}.Name = temp_cell_array{2};
        
        for i=1:size(temp_cell_array, 2)-18
            
            Materials{counter}.Name = [Materials{counter}.Name '_' temp_cell_array{2+i}];
            
        end
        
    end
    
end

% Финализация
if (counter == 0)
    Materials = [];
else
    Materials = Materials(1:counter,:);
end

% Закрытие файла
fclose(Fin);

% Проверка
if (counter == 0)
    fprintf (1, '\nОшибка: пустой файл %s !\n', File_Path);
    ErrCode = -1;
    return;
end

fprintf (1, 'OK!\n');
